#ifndef BASE_
#define BASE_
struct man;
struct drawer;
struct item;

struct man {
	struct drawer *first, *last;
	struct man *next;
};

struct drawer {
	struct stanza *pattern;
	struct drawer *next;
	struct item *first, *last; 
};

struct item {
	struct item *next;
	char *caption;
	char *var;
};

#ifdef BASE_C_
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <conflib.h>
#include <tinterp.h>
#include <ctype.h>

#include "baseconfig.h"	
#include "miscfnc.h"
#include "otakconfig.h"
#include "buf.h"	// guess what ;)

#ifdef BASE_FRIEND_
extern struct man *first_man, *last_man, *current_man;
#endif

#else
extern struct man *first_man, *last_man, *current_man;
#endif
// baseread.c
void put_item(struct drawer *d, char *caption);
void add_drawer(struct man *p, struct stanza *s, char *whole);
void add_new_man(void);
void add_man(struct man *p);
int read_base(char *name);

// baseservice.c
void export_allenv(struct man *m);
int count_men(void);

int find_man_by_string(char *pattern, int);
struct drawer *find_drawer_by_name(struct man *p, char *s);
struct drawer *find_drawer_by_stanza(struct stanza *s);
void scroll_men(long);
char *return_menuname(struct man *p);
char *return_drawer(void);
char *return_man(void);

// basewrie.c
void del_item(struct drawer *d, struct item *i);
void del_drawer(struct man *m, struct drawer *d);
void del_man_from_list(struct man *p);
void del_man(struct man *p);
void free_men(void);
void write_base(char *name);
#endif
