/*
  otak project.
  copyright (C) 2002 
  grzegorz moskal,  <g.moskal@opengroup.org>
  license : gnu gpl version 2 			*/

#define BASE_C_
#define BASE_FRIEND_
#include "base.h"

static struct man *mj;
static struct drawer *dj;
static struct item *ij;

cl_var_t empty[] = {{ NULL, NULL, 0, NULL, 0, NULL}};

static int caption_length(char *s)
{
	char *j = s;
	while (*j && *j != ',')
		j++;
	return j - s;
}

static char *return_caption(char *s)
{
	int len;
	char *ret = 0;
	if ((len = caption_length(s))) {
		ret = strncpy(xmalloc(sizeof(char) * (len+1)), s, len);
		ret[len] = 0;
	}
	return ret;
}

void put_item(struct drawer *d, char *caption)
{
	ij = xmalloc(sizeof(struct item));
	ij->next = 0;
	ij->caption = (caption) ? strdup(caption) : caption;

	if (!d->first)
		d->first = d->last = ij;
	else {
		d->last->next = ij;
		d->last = ij;
	}
}

void add_drawer(struct man *p, struct stanza *s, char *whole)
{
	char *caption; 
	int len;
	if (!p || !s || !whole)
		return;
	dj = xmalloc(sizeof(struct drawer));
	dj->next = 0;
	dj->first = dj->last = 0;
	dj->pattern = s;
	
	if (!p->first)
		p->first = p->last = dj;
	else {
		p->last->next = dj;
		p->last = dj;
	}
		
	while (*whole) 
		if ((caption = return_caption(whole))) {
			len = strlen(caption);
			whole += len;
			put_item(p->last, caption);
			if (*whole)
				whole++;
		}
}

void add_man(struct man *p) 
{
	if (!p)
		return;

	if (!first_man)
		first_man = last_man = current_man = p;
	else {
		last_man->next = p;
		last_man = p;
	}
}
char *label;
cl_var_t configstuff[] ={
	{ "baase-name", NULL,	CL_STRING, &label, 0, NULL },
	{ NULL,	NULL, 0, NULL, 0, NULL}
};

static struct man *init_man(void)
{
	struct man *mj = xmalloc(sizeof(struct man));
	mj->first = mj->last = 0;
	mj->next = 0;
	return mj;
}

void add_new_man(void)
{
	add_man(init_man());
}

int read_base(char *name)
{
	struct stanza *s;
	char **ar, **p;
	cl_var_t *t = empty;
	cl_ulist_t *unknows = NULL, *ptr;
	cl_file_t *handle; 

	if (!name) 
		return 0;

	
	if (!(handle = cl_openconf(name, "lr")))
		if (!(handle = cl_openconf(name, "r"))) 
			return 0;
			
	if (!(ar = cl_build_stanza_array("*", handle))) {
		msgf("empty base file - '%s'", name);
		return 1;
	}

	msgf("read in base file:         '%s'", name);

	for (p = ar; *p && !cl_getstanza(handle, t, *p, 0, &unknows); p++) {
		for (mj = 0, ptr = unknows; ptr; ptr = ptr->next) {
			if (!(s = find_stanza_by_name(ptr->varname)))
				continue;
			if (!mj) 
				mj = init_man();

			add_drawer(mj, s, ptr->inhalt);
			ptr->varname = "NULL";		// ;)
		}

		add_man(mj);
	}
	return 1;
}
