/*
  otak project.
  copyright (C) 2002 
  grzegorz moskal,  <g.moskal@opengroup.org>
  license : gnu gpl version 2 			*/


#define BASE_C_
#include "base.h"

struct man *first_man, *last_man, *current_man;

static struct man *mj;
static struct drawer *dj;
static struct item *ij;

int count_men()
{
	int i = 0;
	for (mj = first_man; mj; mj = mj->next, i++);
	return i;
}

void export_allenv(struct man *m)
{
	clear_allenv();
	setenv("text", "", 1);
	for (dj = m->first; dj; dj = dj->next)
		setenv(dj->pattern->name, dj->first->caption, 1);
}

char *return_drawer()
{
	b_cleanup();
	
	for (dj = current_man->first; dj; dj = dj->next)
		if (dj->pattern == current_stanza)
			break;
	if (dj) 
		for (ij = dj->first; ij; ij = ij->next) {
			b_addstr(ij->caption);
			b_addstr("\n");
		}
	else 
		b_addstr(" -- ");
		
	return b_return();
}

char *return_man()
{
	char *label;
	
	if (!current_man)
		return strdup(" keep smiling ;-) ");
	b_cleanup();
	for (dj = current_man->first; dj; dj = dj->next) {
		int done = 0;
		if (show_labels) {
			char *end = strglue(":\n", space_str, "");
			label = strglue(arrow_str, dj->pattern->label, end);
			xfree(end);
		} else if (dj == current_man->first)
			label = strdup(arrow_str);
		else
			label = strglue(space_str, "\n", arrow_str);
			
		for (ij = dj->first; ij; ij = ij->next) {
	
			b_addstr(label);
			b_addstr(ij->caption);
			b_addstr("\n");
			
			if (done++ == 0) {
				xfree(label);
				label = (show_labels) ? space_str : arrow_str;
			}
		}
	}
	return b_return();
}

int find_man_by_string(char *pattern, int n)
{
	int i = 0;
	char *s, *cmp;
	for (mj = first_man; mj; mj = mj->next, i++)
		for (dj = mj->first; dj; dj = dj->next)
			for (ij = dj->first; ij; ij = ij->next) {
				s = strtolower(ij->caption);
				cmp = strstr(s, pattern);
				xfree(s);
				
				if (cmp)  {
					if (--n < 0) 
						return i;
					ij = dj->last;
					dj = mj->last;
				}
			}
			
	return 0;
}

struct drawer *find_drawer_by_stanza(struct stanza *s)
{
	for (dj = current_man->first; dj; dj = dj->next)
		if (dj->pattern == s)
			break;
	
	return dj;
}

struct drawer *find_drawer_by_name(struct man *p, char *s)
{
	for (dj = p->first; dj; dj = dj->next)
		if (strcmp(s, dj->pattern->name) == 0)
			return dj;
			
	return 0;
}

char *return_menuname(struct man *p)
{
	if ((dj = find_drawer_by_name(p, menu_title)))
		return dj->first->caption;
		
	return p->first->first->caption;
}

void scroll_men(long n)
{
	for (current_man = first_man; n; n--)
		current_man = current_man->next;
}
