/*
  otak project.
  copyright (C) 2002 
  grzegorz moskal,  <g.moskal@opengroup.org>
  license : gnu gpl version 2 			*/

#define OTAKCONFIG_C_
#include "otakconfig.h"

// messages
static int no_messages = 1;
int silent = 0;
int silent_attr = -1;
// a few normal varibles ;)
int sort_database = 1;
int write_database = 1;
int read_wins = 1;
// command line arg.
int confirm_adding = 0;
char *query_arg;
char *new_email_arg;
// files names
char *config_name;
char *base_name;
char *baseconfig_name;
char *basedir_name;
char *size_name;
// shortcuts
char *del_key = "d";
char *add_key = "a";
char *edit_key = "e"; 
char *back_key = "q";
char *quit_key = "q";
char *move_key = "m";
char *load_key = "l";
// stanza varibles
char *enter_cmd = "email";
char *menu_title = "name";
char *query_show = "email";
// ascii arts
int show_intro = 0;
int toolbar_up = 1;
int big_windows = 0;
int hide_wininfo = 0;
int show_labels = 0;
#define DEFAULT_ARROW "-> "
char *arrow_str = DEFAULT_ARROW;
char *space_str;

cl_var_t var[] =
{
	// messages  ..
	{ "silent",		NULL, CL_BOOLEAN, &silent, 0, NULL },
	{ "no.messages",	NULL, CL_BOOLEAN, &no_messages, 0, NULL },
	// normal ..	
	{ "sort.base",		NULL, CL_BOOLEAN, &sort_database, 0, NULL },
	{ "read.size.file",	NULL, CL_BOOLEAN, &read_wins, 0, NULL },
	// files ..
	{ "base.config.file",	NULL, CL_STRING,  &baseconfig_name, 0, NULL },
	{ "base.dir", 		NULL, CL_STRING,  &basedir_name, 0, NULL },
	{ "size.file",		NULL, CL_STRING,  &size_name, 0, NULL },
	// shortcuts ..
	{ "remove.key",		NULL, CL_STRING,  &del_key, 0, NULL },
	{ "add.key",		NULL, CL_STRING,  &add_key, 0, NULL },
	{ "edit.key", 		NULL, CL_STRING,  &edit_key, 0, NULL },
	{ "back.key",		NULL, CL_STRING,  &back_key, 0, NULL },
	{ "move.key",		NULL, CL_STRING,  &move_key, 0, NULL },
	{ "load.key",		NULL, CL_STRING,  &load_key, 0, NULL },
	// stanza varibles ..
	{ "cmd.on.enter",	NULL, CL_STRING,  &enter_cmd, 0, NULL },
	{ "menu.title",		NULL, CL_STRING,  &menu_title, 0, NULL },
	{ "show.query", 	NULL, CL_STRING,  &query_show, 0, NULL },
	// ascii arts ..
	{ "show.intro",		NULL, CL_BOOLEAN, &show_intro, 0, NULL },
	{ "toolbar.up",		NULL, CL_BOOLEAN, &toolbar_up, 0, NULL },
	{ "big.windows",	NULL, CL_BOOLEAN, &big_windows, 0, NULL },
	{ "hide.wininfo",	NULL, CL_BOOLEAN, &hide_wininfo, 0, NULL },
	{ "show.labels",	NULL, CL_BOOLEAN, &show_labels, 0, NULL },
	{ "arrow.string",	NULL, CL_STRING,  &arrow_str, 0, NULL },
	{ NULL,NULL,0,NULL,0, NULL}
};

static void check_otakconf(void)
{

	char *jmp;
	if (strcmp(arrow_str, DEFAULT_ARROW))
		arrow_str = strglue(arrow_str, " ", "");
	jmp = space_str = strdup(arrow_str);
	for (; *jmp; jmp++)
		*jmp = ' ';
		
	if (silent_attr >= 0 && silent != silent_attr)
		silent = silent_attr;
	else {
		if (no_messages)
			silent = MESSAGES;
		else if (silent)
			silent = MESSAGES_AND_ERRORS;
	}
}

int read_otakconf(char *name)
{
	cl_ulist_t *unknows = NULL;
	char **ar, **p;
	cl_var_t *t = var;
	cl_file_t *handle;

	if (!(handle = cl_openconf(name, "lr")))		// patched conflib
		if (!(handle = cl_openconf(name, "r"))) 
			return 0;	
			
	if (!(ar = cl_build_stanza_array("*", handle))) {
		msgf("empty config file - '%s'", name);
		return 1;
	}
	
	for (p = ar; *p  && !cl_getstanza(handle, t, *p, 0, &unknows); p++);
	
	check_otakconf();	
	msgf("read in config file:       '%s'", name);
	
	return 1;
}

