/*
  otak project.
  copyright (C) 2002 
  grzegorz moskal,  <g.moskal@opengroup.org>
  license : gnu gpl version 2 			*/

#define WHELP_C_
#include "whelp.h"

static int show;
static struct tobj *win_help;
static char uk_help[]=
" gnu gpl version 2\n"
"grzegorz moskal, eldevarth /at/ hoga.pl\n"
"\n"
"short overview:\n"
"	The main idea behind otak, is to provide visual interface\n"
"	to programs, that doesn't have one, but needs to take\n"
"	arguments, that can be selected from list.\n"
"	For example one can use it as an address-book program in \n"
"	connection with mutt (that`s default;), or as a phone-book\n"
"	with sms-sending software, or even as list of hosts\n"
"	to ssh or ftp to.\n"
"	See the otakrc(5) man page for more info.\n\n"
"	Press ctrl-c (^C) to quit otak without saving database.\n\n\n"
"otak 'people screen' shortcuts:\n\n"
"	/ - search item (enter, down or up to accept choice)\n"
"	a - add new person and change to screen\n"
"	e, right-arrow - edit current person\n"
"	d - delete current person\n"
"	q - quit otak\n"
"	h, ?, F1 - show this help window\n\n"
"	[database shortcuts]\n"
"	m - move person to the different database\n"
"	l - load database from base.dir (set dir in config file)\n"
"	D - delete database\n"
"	N - create new database\n"
"\n\n"
"otak 'data screen' shortcuts:\n\n"
"	e - turn on edit mode (use arrows keys to change item)\n"
"	enter - use, edit or add if don't exist\n"
"		or multiple item\n"
"	d - delete item\n"
"	esc - cancel operation\n"
"	q, left-arrow - change screen (go to 'people screen')\n\n\n\n"
"tsys 1.1 gnu gpl version 2\n"
"micha stochmiaek, misto /at/ topnet.pl\n"
"\n"
"text-window system (tsys) shortcuts:\n\n"
"	windows:\n"
"	tab   - next window\n"
"	alt+m - move window using arrow keys (accept by enter)\n"
"	alt+n - next widget in window\n"
"	> - scroll list right\n"
"	< - scroll list left\n"
"\n"
"	Input-line:\n"
"	insert - change current input mode (inserting/replacing)\n";

int whelp_create(struct tobj *rootwin)
{
	DEFINE_SIZES(Whelp);
	char *help = translate(uk_help);
	char *hstr = xmalloc(sizeof(char) * 
		(strlen(help)+ strlen(PACKAGE) + strlen(VERSION) + 3));
	sprintf(hstr, "%s %s %s", PACKAGE, VERSION, help);
	
	if (!(win_help = twin_init(rootwin, x, y, w, h, translate("Help"))))
		return 0;
	if (! (ttxtview_init(win_help, 1, 1, w-2, h-2, hstr)))
		return 0;

	tset(win_help, TOBJ_HIDDEN , 1);
	return 1;
}

void whelp_free(void)
{
	set_size(Whelp, win_help);
	tobj_free(win_help);
	win_help = NULL;
}

int whelp_service(struct tevent *e)
{
	if (e->sender != win_help && e->sender && !show)
		return 0;
		
	switch (e->data) {
	case K_ESC:
		whelp_hide();
		return 1;
	}
	return 0;

}

void whelp_set(long attr, long data)
{
	tset(win_help, attr, data);
}

void whelp_show()
{
	tobj_show(win_help);
	show  = 1;
}

void whelp_hide()
{
	tobj_rhide(win_help);
	show = 0;
}

void help_b(struct tobj *obj, long data)
{
	(void) obj;
	(void) data;
	whelp_show();	
}

int whelp_isshowing()
{
	return show;
}
