/*
  otak project.
  copyright (C) 2002 
  grzegorz moskal,  <g.moskal@opengroup.org>
  license : gnu gpl version 2 			*/

#define WTEXT_C_
#include "wtext.h"

static struct tobj *win_text, *line_text;

int wtext_service(struct tevent *e)
{
	if (e->sender != line_text && e->sender != win_text)
		return 0;

	switch (e->data) {
	case EVENT_TINPUT_ACCEPT:
		ltext_service();
		scr_show();
		return 1;
	case EVENT_TINPUT_REJECT:
		scr_refresh();
		return 1;
	}
	
	return 0;
}

void wtext_show()
{
	tobj_show(win_text);
}

void wtext_hide()
{
	tobj_rhide(win_text);
}

void ltext_service()
{
 	char *str = ltext_caption();
	struct drawer *d = current_drawer;
	struct item *i = d->first;
	
	if (str == NULL || *str == '\0')  
		return;
		
	if (i->next)
		i = current_item();
	
	export_allenv(current_man);
	setenv(d->pattern->name, i->caption, 1);
	setenv("text", str, 1);
	call_cmd(d->pattern->command);
	ltext_flush();
}

int ltext_flush()
{
	int reinit = (line_text) ? 1 : 0;
	if (reinit)
		tobj_free(line_text);
	if (!(line_text = tinput_init(win_text, 1, 
		1, get_w(Wtext)-2, "", 1400))) {
		if (reinit)
			errexit("Cannot reinit line_text\n");
		return 0;
	}
	return 1;
}

char *ltext_caption()
{
	return (char *)txget(line_text, TINPUT_BUFFER_CURRENT);
}

int ltext(struct tobj *obj)
{
	return ((obj == line_text) ? 1 : 0);
}

int wtext_create(struct tobj *rootwin)
{
	DEFINE_SIZES(Wtext);
	if (!(win_text = twin_init(rootwin, 
		x, y, w, h, translate("write text"))))
		return 0;
	if (!ltext_flush())
		return 0;
        tset(win_text, TOBJ_HIDDEN, 1);
	
	return 1;
}

void wtext_free(void)
{
	set_size(Wtext, win_text);
	tobj_free(win_text);
	win_text = line_text = NULL;
}

